#!/usr/bin/python3
#
# Copyright (C) 2017 The Android Open-Source Project
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""Utility to generate IntelliJ .iml output

Adding one-by-one all the autogenerated Mojo directories could be error-prone
and difficult to maintain.

This utility is intented to help generating the .iml entries for all the
autogenerated Mojo Java libraries for ARC++.

For more information, run the script with:
  python iml_generator.py -h


Convention used:

  package_name: a Java package name. Ex: org.chromium.arc.my_class
  package_path: path containing the java file.
    Ex: path/to/my/sources/org/chromium/arc/
  source_folder: the entry to be added in the iml <sourceFolder url="..."/>
  prefix_path: path to be prepended to source_folder
"""

import argparse
import codecs
import os
import re
import sys

# how many bytes to read from the java file before aborting
_PACKAGE_READ_LIMIT = 8192
_PACKAGE_REGEXP = r'^package ([\w.]+);'


def _sanitize_package_path(prefix_path, package_path):
  """Return the following operation: package_path - prefix_path.

  Args:
    prefix_path: string that contains the prefix path to add to sourceFolder
    package_path: string that contains the package path
  """
  # Ensure |prefix_path| has a trailing slash to avoid false positives
  prefix_path = os.path.join(prefix_path, '')

  idx = package_path.find(prefix_path)
  if idx == -1:
    return package_path
  return package_path[idx + len(prefix_path):]


def _get_package_name_from_file(root, filename):
  """Return the package name inside a valid java file."""
  # process only .java files, and try to find a package directive
  if os.path.splitext(filename)[1] != '.java':
    return None

  try:
    with codecs.open(os.path.join(root, filename), 'r', encoding='utf-8',
                     errors='ignore') as fd:
      data = fd.read(_PACKAGE_READ_LIMIT)
      groups = re.search(_PACKAGE_REGEXP, data, re.MULTILINE)
      return groups.group(1) if groups else None
  except Exception as e:
    sys.stderr.write("WARNING: Could not process %s.(%s)\n" %
                     (os.path.join(root, filename), e))
    return None


def _get_source_folder_for_package_name(package_path, package_name):
  """Return the sourceFolder for a given |package_name|.

  Args:
    package_path: string that contains the full path to the package
    package_name: string that contains a valid java package name
  """
  p = package_name.replace('.', '/')

  # start from the rightmost part. otherwise it could return an incorrect path
  idx = package_path.rfind(p)
  if idx == -1:
    return None
  return package_path[0:idx]


def _find_all_valid_paths(path):
  """Find all valid path

  Traverse the whole |path| trying to find valid path that for packages that
  are inside of each .java file

  Args:
    path: root path that might contain many valid sub paths
  """
  folders_to_add = set()

  for root, dirs, files in os.walk(path):
    for f in files:
      package = _get_package_name_from_file(root, f)
      if package is None:
        continue

      source_folder = _get_source_folder_for_package_name(root, package)

      if source_folder is None:
        continue

      folders_to_add.add(source_folder)
      # no need to keep processing this directory
      break

  return folders_to_add


def _generate_output(output_fd, prefix_path, paths_to_add):
  """Generate the output using |output_fd| as file object."""
  # <sourceFolder url="file://$MODULE_DIR$/out/target/common/obj/JAVA_LIBRARIES/arcbridge_intermediates/src" isTestSource="false" />
  template = '      <sourceFolder url="file://$MODULE_DIR$/%s" isTestSource="false" />\n'

  output_fd.write('      <!-- BEGIN: AUTOGENERATED. DO NOT EDIT -->\n')
  for entry in sorted(paths_to_add):
    output_fd.write(template % (os.path.join(prefix_path, entry)))
  output_fd.write('      <!-- END: AUTOGENERATED. DO NOT EDIT -->\n')


def _run(prefix_path, paths_to_parse, output_fd=sys.stdout):
    """Run the iml generator.

    Args:
      prefix: the path to prepend to the sourceFolder iml entry
      paths_to_parse: collection of directories to parse
      output_fd: where to write the output (default sys.stdout)
    """
    paths_to_add = set()
    for path in paths_to_parse:
      paths_to_add.update(_find_all_valid_paths(path))

    sanitized_paths_to_add = set(
        _sanitize_package_path(prefix_path, path) for path in paths_to_add)

    _generate_output(output_fd, prefix_path, sanitized_paths_to_add)


def _parse_args():
  """Parse the arguments."""
  parser = argparse.ArgumentParser(
      formatter_class=argparse.RawDescriptionHelpFormatter,
      description='Generates IntelliJ .iml output from java files. Useful to'
      'parse the autogenerated Android Mojo files.',
      epilog="""Examples:

Generate iml for all the autogenerated Mojo files
$ %(prog)s ~/src/android/out/target/common/obj/JAVA_LIBRARIES/*

Generate iml for all framework* Mojo files,  using iml.xml for output file
$ %(prog)s -o iml.xml ~/src/android/out/target/common/obj/JAVA_LIBRARIES/framework*

Generate iml using output file and custom prefix path
$ %(prog)s -o output.xml -p out/target/common/obj/JAVA_LIBRARIES/arcbridge_intermediates  *

""")

  parser.add_argument(
      'paths', metavar='<path>', nargs='+', help='paths to parse. The ones that'
      'have the .java files')
  parser.add_argument(
      '-p', '--prefix-path', metavar='<path>',
      default='out/target/common/obj/JAVA_LIBRARIES/',
      help='path that will be appended to every entry in the iml file. '
      'Default: %(default)s')
  parser.add_argument(
      '-o', '--output-file', metavar='<filename>',
      help='output file. Default: stdout')
  args = parser.parse_args()
  return args


def main():
  """Run the parser and generate the output"""
  args = _parse_args()

  if args.output_file is not None:
    with open(args.output_file, 'w+') as fd:
      _run(args.prefix_path, args.paths, fd)
  else:
    _run(args.prefix_path, args.paths, sys.stdout)


if __name__ == '__main__':
  main()
